<?php

// TM Offline Stats v1.1

/* - commentary ------------------------------------------------------
   This file allows you to manage the process of parsing logs.

   Usage:
   - do changes
   - save file
   - reparse stats

   Tips:
   - if you don't understand what you do, make DB backup first =)
   - if you want use non latin (UTF-8) characters, open this file in
     UTF-8 editor (like windows notepad or http://www.unipad.org)
   - if you want use " in string do it with backslash - \"

   -!commentary --------------------------------------------------- */

/* - commentary ------------------------------------------------------
   Results of this players will by united. Format:
   $cfg_players = array(
      "SrcPlayerAccount"=>"DestPlayerAccount",
   );
   All results of player with account "SrcPlayerAccount" will
   be grabed by player with account "DestPlayerAccount". Player
   with account "SrcPlayerAccount" will be deleted from stats.
   You may view "account" in server's log-file.

   Example for /lan server:

   [2007/01/19 17:30:37] <time> [$000jago/213.85.135.45:2350 ($000Jago)] 1:18.47
   account - "$000jago"
   [2007/01/19 18:07:52] <time> [habicht/192.168.61.175:2350 (HabichT)] 1:29.61
   account - "habicht"

   $cfg_players = array(
      "$000jago"=>"habicht",
   );

   Example for /internet server:

   [2006/06/14 14:01:59] <time> [wjp84 ($i$f4fWJP)] 0:33.80
   account - "wjp84"
   [2006/06/14 14:02:07] <time> [saimi (zymiC)] 0:41.77
   account - "saimi"
   [2006/06/14 14:03:32] <time> [-a-p- (-A-P-)] 0:45.53
   account - "-a-p-"

   $cfg_players = array(
      "wjp84"=>"saimi",
      "-a-p-"=>"saimi",
   );
   -!commentary --------------------------------------------------- */

$cfg_players = array(
);

/* - commentary ------------------------------------------------------
   Results of this players will by deleted. Format:
   $cfg_players_ignorelist = array(
      "DeletePlayerAccount",
   );
   Player with account "DeletePlayerAccount" and all his results
   will by deleted from stats. You may view "account" in
   server's log-file.

   Example for /lan server:

   [2007/01/19 17:30:37] <time> [$000jago/213.85.135.45:2350 ($000Jago)] 1:18.47
   account - "$000jago"
   [2007/01/19 18:07:52] <time> [habicht/192.168.61.175:2350 (HabichT)] 1:29.61
   account - "habicht"

   $cfg_players_ignorelist = array(
      "$000jago",
      "habicht",
   );

   Example for /internet server:

   [2006/06/14 14:01:59] <time> [wjp84 ($i$f4fWJP)] 0:33.80
   account - "wjp84"
   [2006/06/14 14:02:07] <time> [saimi (zymiC)] 0:41.77
   account - "saimi"
   [2006/06/14 14:03:32] <time> [-a-p- (-A-P-)] 0:45.53
   account - "-a-p-"

   $cfg_players_ignorelist = array(
      "wjp84",
      "saimi",
      "-a-p-",
   );
   -!commentary --------------------------------------------------- */

$cfg_players_ignorelist = array(
);

/* - commentary ------------------------------------------------------
   Switch on/off autoparse team-tags. If false, will be used only
   $cfg_clans array.
   true - on
   false - off
   -!commentary --------------------------------------------------- */

$cfg_autofindclans = true;

/* - commentary ------------------------------------------------------
   With this array you can manual register teams. Format:
   $cfg_clans = array(
      "TeamTag"=>array("description"=>"Description: full name, site, mirc channel, e.t.c.",
                       "autofindmembers"=>true,
                       "members"=>"account_member_1;account_member_2;account_member_e_t_c"),
   );
   "TeamTag" is case-insensitive.

   Example:

   $cfg_clans = array(
      "BANANAS"=>array("description"=>" - BANANAS clan",
                       "autofindmembers"=>true),
       "UnItEd"=>array("description"=>" - Some players united to clan",
                       "autofindmembers"=>false,
                       "members"=>"crockett;fleckman;hsl;vasia."),
       "[TMos]"=>array("description"=>" - \"TM Offline Stats\" funs (http://tmos.pp.ru)",
                       "autofindmembers"=>true,
                       "members"=>"$000jago;habicht;rock"),
   );

   -!commentary --------------------------------------------------- */

$cfg_clans = array(

   // information from http://tm-ladder.com (few random teams)
   "{+}"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://savoysrv.viallet.biz\">Team savoy</a>",
                 "autofindmembers"=>true),
   "2fast4u"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://2fast4u.roxorgamers.com\">2fast4u</a>",
                 "autofindmembers"=>true),
   "[BBD]"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.bbd.ze.cx\">Belgium Best Drivers</a>",
                 "autofindmembers"=>true),
   "[BLR]"=>array("description"=>" - <img src=\"./gfx/flags/rus.png\" class=\"f\">&nbsp;<a href=\"http://www.tm-belarus.com\">Belarus team</a>",
                 "autofindmembers"=>true),
   "~CAT>"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://cat.tmu.free.fr\">Catl li</a>",
                 "autofindmembers"=>true),
   "[CDD]"=>array("description"=>" - <img src=\"./gfx/flags/pol.png\" class=\"f\"><img src=\"./gfx/flags/gbr.png\" class=\"f\">&nbsp;<a href=\"http://cddclan.republika.pl\">Crazy Demo Drivers</a>",
                 "autofindmembers"=>true),
   "[cHoe]"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.chaos-hoernchen.de\">Choas-Hoernchen</a>",
                 "autofindmembers"=>true),
   "*CRT*"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.cologne-racing-team.de\">Cologne Racing Team</a>",
                 "autofindmembers"=>true),
   "*CZ*"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.sweb.cz/prizdisracz\">PrizdiSraCZ</a>",
                 "autofindmembers"=>true),
   "]DoW["=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://martin.tibit.de/andre\">DriveOrWalk Team</a>",
                 "autofindmembers"=>true),
   "-=E.T.M=-"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://team.etm.free.fr\">Enter The Matrix</a>",
                 "autofindmembers"=>true),
   "(FG)"=>array("description"=>" - <img src=\"./gfx/flags/gbr.png\" class=\"f\">&nbsp;<a href=\"http://www.forsaken-gaming.com/home\">Forsaken Gaming</a>",
                 "autofindmembers"=>true),
   "Furia"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://teamfuria.cmonfofo.com\">teamfuria</a>",
                 "autofindmembers"=>true),
   "|GT|"=>array("description"=>" - <img src=\"./gfx/flags/pol.png\" class=\"f\">&nbsp;<a href=\"http://www.gtteam.ovh.org\">Gothic Trackers</a>",
                 "autofindmembers"=>true),
   "JBRT"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.jbrteam.info\">Joe Bar Racing Team</a>",
                 "autofindmembers"=>true),
   "KK`"=>array("description"=>" - <img src=\"./gfx/flags/esp.png\" class=\"f\">&nbsp;<a href=\"http://www.kkteam.es.kz\">KK team</a>",
                 "autofindmembers"=>true),
   "NWT"=>array("description"=>" - <img src=\"./gfx/flags/por.png\" class=\"f\">&nbsp;<a href=\"http://nwt.up.md/modules/news\">North Wind Traders</a>",
                 "autofindmembers"=>true),
   "OLD/"=>array("description"=>" - <img src=\"./gfx/flags/nor.png\" class=\"f\">&nbsp;<a href=\"http://teamold.activebb.net\">Overaged Lucky Drivers</a>",
                 "autofindmembers"=>true),
   "plan-B"=>array("description"=>" - <img src=\"./gfx/flags/aut.png\" class=\"f\">&nbsp;<a href=\"http://www.plan-b.at\">plan-B Team</a>",
                 "autofindmembers"=>true),
   "USSRx"=>array("description"=>" - <img src=\"./gfx/flags/rus.png\" class=\"f\">&nbsp;<a href=\"http://www.ussr-team.com\">USSR Team.tmn</a>",
                 "autofindmembers"=>true),
   "BRW@TMN"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.brwclan.redio.de\">Team Brauweiler</a>",
                 "autofindmembers"=>true),
   "[SP]"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.spieleplanet.eu\">SpielePlanet</a>",
                 "autofindmembers"=>true),

);

/* - commentary ------------------------------------------------------
   With this array you can delete "bad" team-tags, that will not show
   in statistics. Format:
   $cfg_clans_ignorelist = array(
      "TeamTag 1",
      "TeamTag 2",
      "TeamTag e.t.c",
   );
   "TeamTag" is case-insensitive.
   -!commentary --------------------------------------------------- */

$cfg_clans_ignorelist = array(

'!0n', '!ck', '!el', '!ger', '!ght', '!ke', '!ls', '!ng', '!nk', '!sher',
'(au)', '(cz)', '(fin)', '(rus)', ')chris', '0ne', '13b', '23rus', '37reg',
'6a6ka', 'Bober', '[fin]', '[ger]', '[nl]', '[rus]', ']benny', ']dragon',
']martin', ']max', ']shorty', ']terror', ']tiger', ']tom', ']toxic', 'abc',
'action', 'ad', 'adam', 'adskii', 'aero', 'agent', 'air', 'aj', 'aka', 'aki',
'al', 'alan', 'ale', 'ale$', 'aleks', 'aleksey', 'alex', 'alexander',
'alexandre', 'alexey', 'alfa', 'ali', 'alien', 'alonso', 'alpha', 'am', 'amit',
'an', 'ana', 'andi', 'andre', 'andreas', 'andrew', 'andrey', 'andy', 'angel',
'angry', 'ann', 'anti', 'antoine', 'anton', 'anty', 'aris', 'arm', 'army',
'arno', 'art', 'artem', 'arthur', 'artur', 'as', 'ass', 'atze', 'aut', 'axel',
'babylon', 'back', 'bad', 'bam', 'baron', 'bastard', 'be', 'ben', 'bender',
'beqa', 'best', 'bez', 'bg', 'big', 'biker', 'bill', 'bishop', 'bj', 'bjoern',
'bl', 'bl!', 'black', 'bln', 'blo', 'blood', 'bloody', 'blue', 'bo', 'bob',
'bobby', 'body', 'bog', 'bond', 'bone', 'bong', 'boris', 'boss', 'bou', 'boy',
'br', 'brot', 'bruno', 'bu', 'bull', 'bushido', 'buster', 'by', 'cK', 'caio',
'can', 'capt', 'captain', 'car', 'carlos', 'carter', 'cat', 'catch', 'cc', 'ce',
'cem', 'cesar', 'ch', 'champion', 'chaos', 'charles', 'chicken', 'chill',
'chilla', 'chris', 'christian', 'christoph', 'chto', 'chuck', 'city', 'cj', 'ck',
'clem', 'coca', 'cola', 'com', 'commander', 'cool', 'cooler', 'cpt', 'cr',
'crazy', 'cro', 'crow', 'cry', 'css', 'cupa', 'cyber', 'cz', 'cze', 'd1mon',
'da', 'dachs', 'damir', 'dan', 'daniel', 'danny', 'dark', 'darkangel', 'darth',
'das', 'dave', 'david', 'davidoff', 'db', 'dc', 'ddy', 'de', 'dead', 'deaf',
'death', 'ded', 'dein', 'deine', 'deltaua', 'deluxe', 'demon', 'den', 'denis',
'dennis', 'der', 'dereal', 'devil', 'di', 'diablo', 'die', 'dim', 'dima',
'dimas', 'dimon', 'diogo', 'dirty', 'disco', 'dj', 'django', 'dk', 'dmitri',
'do', 'doc', 'doctor', 'dog', 'dok', 'dominik', 'don', 'dong', 'doom', 'dr',
'dragon', 'driver', 'du', 'du26', 'du73', 'duck', 'duda', 'dude', 'dutch', 'eat',
'eatmy', 'ed', 'edy40', 'edy40lat', 'egor', 'ehuba', 'el', 'electro', 'elite',
'elvin', 'em', 'emil', 'en', 'enzo', 'er', 'eric', 'erick', 'erik', 'es', 'et',
'eve', 'evgen', 'evil', 'evo', 'ex', 'exe', 'ey', 'eye', 'f1', 'fabi', 'fabian',
'fabio', 'fam', 'fan', 'fast', 'father', 'faust', 'fcn', 'fe', 'felix', 'fenix',
'fernando', 'ferrari', 'filou', 'fin', 'fire', 'first', 'fish', 'fix', 'flash',
'flip', 'flo', 'florian', 'fluffy', 'flying', 'force', 'forever', 'fox', 'fr',
'fra', 'frag', 'franck', 'frank', 'freak', 'fred', 'free', 'fresh', 'fri',
'frog', 'from', 'fromhell', 'frosch', 'fuck', 'fun', 'funky', 'fury', 'fx', 'ga',
'galhao', 'gamer', 'gandalf', 'general', 'george', 'ger', 'german', 'gerry',
'ghost', 'girl', 'gll', 'gmailcom', 'god', 'gold', 'gott', 'gr', 'graf',
'grassi', 'gray', 'great', 'green', 'grey', 'gt', 'gtr', 'guest', 'guest,',
'gustavo', 'guy', 'hamster', 'hannover', 'hans', 'happy', 'hardcore', 'harry',
'hatter', 'he', 'hell', 'helmchen', 'hero', 'herr', 'hey', 'hg', 'hh', 'hik',
'hill', 'hitler', 'hitman', 'homer', 'honza', 'hot', 'hotmailcom', 'hp', 'hro',
'http://', 'hugo', 'hunter', 'iam', 'ice', 'igor', 'ii', 'iii', 'il', 'ilya',
'im', 'in', 'inc', 'ing', 'ir', 'iron', 'is', 'it', 'itamin', 'its', 'ivan',
'ivo', 'izhevsk', 'ja', 'jack', 'jah', 'james', 'jan', 'jazz', 'jb', 'je',
'jean', 'jeff', 'jens', 'jet', 'jim', 'jo', 'joao', 'joe', 'joey', 'johannes',
'john', 'johnny', 'johnson', 'johny', 'jojo', 'joker', 'jon', 'jonas', 'jonny',
'jorge', 'jos', 'josh', 'jozko', 'jr', 'juju', 'juli', 'julian', 'julien',
'julius', 'junior', 'just', 'ka', 'kaeptn', 'kai', 'kak', 'kaktak', 'kalle',
'kamil', 'kan', 'karatel', 'karl', 'kart', 'kasper', 'kay', 'kaz', 'ke', 'keni',
'kenny', 'kettu', 'kev', 'kevin', 'kid', 'kiki', 'kill', 'killa', 'killer',
'kim', 'kimi', 'king', 'kirill', 'kis', 'kiz', 'kl', 'klaus', 'knight', 'ko',
'kok', 'kong', 'kool', 'kostya', 'kot', 'kr', 'ksk', 'kuba', 'kun', 'kz', 'la',
'lady', 'lan', 'lancer', 'lapin', 'lars', 'latvia', 'law', 'lazy', 'le', 'leao',
'leboss', 'lee', 'leo', 'leon', 'les', 'letspb', 'lex', 'lexa', 'lie', 'life',
'light', 'lil', 'link', 'linkin', 'linus', 'lion', 'lithuania', 'little', 'lo',
'loco', 'lol', 'lolo', 'long', 'lord', 'los', 'lost', 'lou', 'love', 'lp', 'lt',
'lu', 'lucas', 'lucifer', 'lucky', 'luis', 'lukas', 'luke', 'lux', 'm5', 'mac',
'maciek', 'mad', 'mads', 'madzia', 'magic', 'magnus', 'mago', 'mailcom',
'mailru', 'maitre', 'maj', 'major', 'mak', 'maker', 'maks', 'malina', 'man',
'mania', 'maniac', 'mann', 'marc', 'marcel', 'marco', 'marcos', 'marek', 'maria',
'mario', 'marius', 'mark', 'marko', 'martin', 'masta', 'master', 'masterm',
'masterof', 'mat', 'mathieu', 'mati', 'matt', 'max', 'maxi', 'maxim', 'maxime',
'maximilian', 'maximus', 'mc', 'md', 'mdk', 'me', 'meh', 'mehmet', 'meister',
'men', 'mendes', 'mert', 'messi', 'metal', 'mg', 'mi', 'michael', 'mickey',
'mighty', 'miha', 'mike', 'miki', 'mini', 'misha', 'miss', 'mister', 'mix', 'mk',
'mm', 'mo', 'moll', 'monkey', 'moon', 'moritz', 'moscow', 'mother', 'moto', 'mr',
'mrs', 'ms', 'my', 'myxa', 'nad', 'nah', 'naruto', 'nathan', 'ne', 'neo', 'neon',
'nero', 'net', 'new', 'next', 'nfs', 'nick', 'nico', 'nicolas', 'nielsen',
'night', 'nik', 'nikita', 'niko', 'ninja', 'nitro', 'nl', 'no', 'no1', 'noir',
'noob', 'nos', 'noy', 'nr1', 'ns', 'oOo', 'oberon', 'obi', 'oe', 'off', 'oh',
'ok', 'old', 'ole', 'oleg', 'oli', 'oliveira', 'olivier', 'om', 'omaha', 'omg',
'on', 'ond', 'ondra', 'one', 'onkel', 'oo', 'oren', 'org', 'oscar', 'ot', 'otto',
'out', 'pahan', 'pan', 'panda', 'papa', 'pascal', 'pasha', 'pat', 'patrick',
'patriot', 'patryk', 'paul', 'paulo', 'pavel', 'pc', 'pedro', 'penis', 'peter',
'petit', 'petrovich', 'ph', 'phil', 'philipp', 'pierre', 'pikachu', 'pilot',
'pink', 'pl', 'player', 'pol', 'polska', 'potato', 'power', 'prapor', 'prinz',
'prisoner', 'pro', 'prosto', 'ps', 'psy', 'pt', 'ptit', 'punisher', 'punk',
'quentin', 'qwe', 'qwerty', 'ra', 'race', 'racer', 'racing', 'rafael', 'rage',
'ramblerru', 'rambo', 'raser', 'rato', 'raul', 'ray', 'rayane', 'razor', 'razzo',
'rb', 'rc', 'rco', 'rd', 'real', 'reaper', 'red', 'remi', 'rey', 'ricardo',
'richard', 'rider', 'ripper', 'rk', 'rma', 'road', 'rob', 'robase', 'robin',
'rocha', 'rock', 'rockn', 'rocks', 'rodrigo', 'rok', 'roll', 'rom', 'roma',
'romain', 'roman', 'ronaldo', 'rookie', 'root', 'rosso', 'rostov', 'rox', 'roy',
'rr', 'rs', 'ru', 'rui', 'runner', 'rus', 'russ', 'russia', 'russian', 'sa',
'sad', 'sam', 'san', 'sanek', 'santa', 'sanya', 'sasa', 'sasha', 'schlumpf',
'schoko', 'schumi', 'se', 'seb', 'sebastian', 'sebastien', 'sen', 'sensei',
'ser', 'serbia', 'serega', 'serg', 'sergey', 'sergio', 'sex', 'sh', 'sha',
'shadow', 'shadowof', 'shark', 'sheep', 'short', 'silent', 'silver', 'sim',
'simon', 'sir', 'sk', 'ska', 'skill', 'sky', 'slam', 'slayer', 'sly', 'sm',
'smile', 'smz', 'sna', 'snake', 'sniper', 'snow', 'soldier', 'solid', 'song',
'sonic', 'sos', 'sp', 'space', 'spb', 'speed', 'speedracer', 'speedy', 'spirit',
'sponge', 'sr', 'srt', 'ss', 'st', 'stalke', 'star', 'steel', 'stefan', 'steve',
'steven', 'stone', 'street', 'streetracing', 'strike', 'style', 'su', 'sunny',
'super', 'supersonic', 'sven', 'svk', 'swe', 'sz', 'szymon', 'tank', 'taxi',
'te', 'team', 'teh', 'tema', 'ter', 'terminator', 'tha', 'the', 'thebest',
'theblack', 'thegreat', 'thekiller', 'theking', 'thereal', 'the~', 'this',
'thisis', 'thomas', 'ti', 'tiago', 'tiger', 'tim', 'timbo', 'titan', 'titi',
'tj', 'tm', 'tobi', 'tod', 'todd', 'tom', 'tommy', 'tonton', 'tony', 'toto',
'toxa', 'toxic', 'tr', 'track', 'trackmania', 'ttp://', 'tueurs', 'tuoppi',
'tupac', 'turbo', 'turkey', 'turtle', 'tv', 'tyler', 'ua', 'ufo', 'ui', 'uk',
'ukr', 'ukraine', 'ultimativ', 'ultra', 'un', 'unit', 'unlimited', 'urist',
'usa', 'user', 'ussr', 'vadim', 'vampire', 'vano', 'ver', 'vic', 'victor',
'vinc', 'vince', 'vincent', 'viper', 'virus', 'vit', 'vitamin', 'vitek', 'viva',
'vlad', 'vocuk', 'vodka', 'vovan', 'vs', 'war', 'warrior', 'water', 'weed',
'west', 'white', 'who', 'will', 'willy', 'win', 'winner', 'winter', 'wo', 'wolf',
'wow', 'ww', 'www', 'x3', 'x6', 'xa', 'xd', 'xtreme', 'xx', 'xxl', 'xxx', 'ya',
'yahoocom', 'yandexru', 'yannik', 'yeah', 'yeti', 'yo', 'you', 'ze', 'zerg',
'zero', 'marques', 'balboa', 'zloy', 'stalk', 'stal', 'sta', 'zi', '\'mad',
'zebra',

);



/* - commentary ------------------------------------------------------
   All results of all players on this tracks will be deleted. Format:
   $cfg_tracks_ignorelist = array(
      "track_uid",
   );

   You may view "track_uid" in matchsettings file or in server's log-file.

   Example:

   [2006/06/14 14:00:41] Loading challenge E-3.Challenge.Gbx (yxUTF2YQd351q4iWVtrrqYV59tk)...
   track_uid - "yxUTF2YQd351q4iWVtrrqYV59tk"

   $cfg_tracks_ignorelist = array(
      "yxUTF2YQd351q4iWVtrrqYV59tk",
   );
   -!commentary --------------------------------------------------- */

$cfg_tracks_ignorelist = array(
);

?>